<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta name="keywords" content="Markov decision process, Toolbox, Scilab">
   <title> mdp_bellman_operator description </title>
</head>
<body bgcolor="#FFFFFF">

<center><table BORDER=0 CELLSPACING=0 CELLPADDING=0 COLS=2 WIDTH="100%" BGCOLOR="#FFFFCC" NOSAVE >
<tr BGCOLOR="#FFFFCC" NOSAVE>
<td BGCOLOR="#FFFFCC" NOSAVE><b>MDP Toolbox for Scilab</b></td>
<td><div align=right><a href="DOCUMENTATION.html"><img SRC="arrow.gif" height=23 width=26></a></div></td>
</tr>
</table></center>

<p><b><font color="#FF0000"><font size=+2>mdp_bellman_operator</font></font></b>
<p><font color="#000000">
Applies the Bellman operator to a value function Vprev and returns a new value function and a Vprev-improving policy.<br>
</font>


<p><b><font color="#3366FF"><font size=+1>Syntax</font></font></b>
<p><font color="#000000"><b> </b>[V, policy] = mdp_bellman_operator(P, PR, discount, Vprev)</font>


<p><b><font color="#3366FF"><font size=+1>Description</font></font></b>
<font color="#000000">
<p>mdp_bellman_operator applies the Bellman operator: PR + discount*P*Vprev to the value function Vprev.<br>
Returns a new value function and a Vprev-improving policy.<br>
</font>


<p><b><font color="#3366FF"><font size=+1>Arguments</font></font></b>
<font color="#000000">
<ul><li><b>P : </b>transition probability array.</li></ul>
P can be a 3 dimensions array (SxSxA) or a cell array (1xA), each cell containing a sparse matrix (SxS).
<ul><li><b>PR : </b>reward array.</li></ul>
PR can be a 2D array (SxA) possibly sparse.
<ul><li><b>discount : </b>discount factor.</li></ul>
 discount is a real number belonging to ]0; 1].
<ul><li><b>Vprev :</b> value fonction.</li></ul>
Vprev is a (Sx1) vector.
</font>


<p><b><font color="#3366FF"><font size=+1>Evaluations</font></font></b>
<font color="#000000">
<ul><li><b>V :</b> new value fonction.</li></ul>
V is a (Sx1) vector.
<ul><li><b>policy : </b>a policy.</li></ul>
policy is a (Sx1) vector. Each element is an integer corresponding to an action.
</font>

<p><b><font color="#3366FF"><font size=+1>Example</font></font></b>
<font color="#000000">

<p->> P(:,:,1) = [ 0.5 0.5; &nbsp 0.8 0.2 ];<br>
-> P(:,:,2) = [ 0   1; &nbsp 0.1 0.9 ];<br>
-> R = [ 5 10; &nbsp -1 2 ];<br>
<br>
-> [V, policy] = mdp_bellman_operator(P, R, 0.9, [0;0])<br>
V =<br>
&nbsp&nbsp    10<br>
&nbsp&nbsp    2<br>
policy =<br>
&nbsp&nbsp     2<br>
&nbsp&nbsp     2<br>
<br>
In the above example, P can be a cell array containing sparse matrices:<br>
-> P(1) = sparse([ 0.5 0.5;&nbsp   0.8 0.2 ]);<br>
-> P(2) = sparse([ 0 1;&nbsp   0.1 0.9 ]);<br>
The function call is unchanged.<br>
</font>


<br><br>
<table BORDER=0 CELLSPACING=0 CELLPADDING=0 COLS=2 WIDTH="100%" BGCOLOR="#FFFFCC" NOSAVE >
<tr NOSAVE>
<td NOSAVE><b>MDP Toolbox for Scilab</b></td>
<td><div align=right><a href="DOCUMENTATION.html"><img SRC="arrow.gif" height=23 width=26></a></div></td>
</tr>
</table>

<br><br>
<hr WIDTH="100%">
<font size=-1>File : MDPtoolbox/documentation/mdp_bellman_operator.html</font>
<br><font size=-1>Page created on July 31, 2001. Last update on August 31, 2009.</font>
</body>
</html>
